<template>
    <div :class="{opened: isOpened}" class="order_filters filter_container">
        <div class="close" @click="closeFilter"><plus-svg></plus-svg></div>
        <div class="filter_title">{{$t('message.filter')}}</div>
        <div class="input_block">
            <div class="input_component">
                <datetime
                    v-model="filters.date_from"
                    :phrases="datepicker.phrases"
                    :minDatetime="datePickerMinDate"
                    :maxDatetime="datePickerMaxDate"
                    :inputClass="{filled: filledInputs.date_from}"
                    :auto="true"
                    @input="changeInputStatus('date_from', !!filters.date_from)"
                    format="dd.MM.yyyy"
                    class="vdp-datepicker"
                >
                    <div class="lbl_datepicker" slot="after">{{ $t('message.created_at_from') }}</div>
                </datetime>
            </div>
            <div class="input_component">
                <datetime
                    v-model="filters.date_to"
                    :phrases="datepicker.phrases"
                    :minDatetime="datePickerMinDate"
                    :maxDatetime="datePickerMaxDate"
                    :inputClass="{filled: filledInputs.date_to}"
                    :auto="true"
                    @input="changeInputStatus('date_to', !!filters.date_to)"
                    format="dd.MM.yyyy"
                    class="vdp-datepicker"
                >
                    <div class="lbl_datepicker" slot="after">{{ $t('message.created_at_to') }}</div>
                </datetime>
            </div>
            <div class="input_component">
                <cities-input
                    v-model="placeholders.receiver_city"
                    :cities="cities"
                    :placeholder="$t('message.leave_place')"
                    @set-city="setCity"
                    class="order"
                ></cities-input>
            </div>
            <div class="input_component">
                <department-input
                    v-model='placeholders.receiver_department'
                    :departments="availableDepartments"
                    :placeholder="$t('message.department_no')"
                    @set-department="setDepartment"
                ></department-input>
            </div>
            <div class="input_component">
                <input
                    v-model="filters.receiver_name"
                    type="text"
                    :placeholder="$t('message.receiver_surname')"
                    :class="{'active_focus': filledInputs.receiver_name || filters.receiver_name}"
                    @focus="changeInputStatus('receiver_name', true)"
                    @blur="changeInputStatus('receiver_name', false)"
                >
                <div class="lbl">{{ namePlaceholder }}</div>
            </div>
            <div class="input_component">
                <the-mask
                    v-model='filters.receiver_phone'
                    type="text"
                    :mask="['+38 (0##) ###-##-##']"
                    :placeholder="$t('message.receiver_phone')"
                    :class="{'active_focus': filters.receiver_phone}"
                    @focus="changeInputStatus('receiver_phone', true)"
                    @blur="changeInputStatus('receiver_phone', false)"
                ></the-mask>
                <div class="lbl">{{ phonePlaceholder }}</div>
            </div>
        </div>
        <div class="buttons">
            <button class="button" @click="resetFilters">{{ $t('message.reset_filters') }}</button>
            <button class="button" @click="applyFilters">{{ $t('message.apply_filters') }}</button>
        </div>
    </div>
</template>

<script>
    import { Datetime } from 'vue-datetime';
    import { Settings } from 'luxon';
    import 'vue-datetime/dist/vue-datetime.css';
    import Plus  from "../../svg/Plus";
    import CitiesInput from "../../DeliveryCalculator/CitiesInput";
    import DepartmentInput from "../../DeliveryCalculator/DepartmentInput";

    export default {
        components: {
            "plus-svg": Plus,
            Datetime,
            CitiesInput,
            DepartmentInput
        },
        props: ['isOpened', 'isIncomming', 'cities', 'departments'],
        data(){
            return {
                filters: {
                    date_from: '',
                    date_to: '',
                    receiver_city: '',
                    receiver_department_number: '',
                    receiver_name: '',
                    receiver_phone: ''
                },
                filledInputs: {
                    date_from: false,
                    date_to: false,
                    receiver_name: false,
                    receiver_phone: false,
                },
                placeholders: {
                    receiver_city: '',
                    receiver_department: '',
                },
                datepicker: {
                    phrases: {
                        ok: this.$t('message.ok'),
                        cancel: this.$t('message.cancel')
                    }
                },
                availableDepartments: []
            }
        },
        computed: {
            phonePlaceholder(){
                return this.isIncomming ? this.$t('message.phone_sender') : this.$t('message.receiver_phone');
            },
            namePlaceholder(){
                return this.isIncomming ? this.$t('message.sender_surname') : this.$t('message.receiver_surname');
            },
            datePickerMinDate(){
                const date = new Date();
                date.setFullYear( date.getFullYear() - 1 );
                return date.toISOString();
            },
            datePickerMaxDate(){
                return new Date().toISOString();
            }
        },
        methods: {
            closeFilter(){
                this.$emit('close');
            },
            changeInputStatus(field, status){
                this.filledInputs[field] = status;
            },
            setCity(city){
                this.filters.receiver_city = city.name_ua;
                this.placeholders.receiver_city = this.generateCityPlaceholder(city, city.region);
                // оставляем только департаменты по выбранному городу
                this.availableDepartments = city.departments;
            },
            generateCityPlaceholder(city, region){
                let cityName = '';
                cityName += city ? city.name_ua : '';
                cityName += region ? ` (${region.name_ua} обл.)` : '';
                return cityName;
            },
            setAvailableDepartmantsByCityUuid(city_uuid){
                const departments = this.departments.filter(item => {
                    return item.city_uuid === city_uuid;
                });
                return departments;
            },
            setDepartment(department){
                if( department.city ){
                    this.filters.receiver_city = department.city.name_ua;
                    this.placeholders.receiver_city = this.generateCityPlaceholder(department.city, department.region);
                    this.availableDepartments = this.setAvailableDepartmantsByCityUuid(department.city_uuid);
                }
                this.filters.receiver_department_number = department.department_no;
                this.placeholders.receiver_department = `${department.department_no} ${department.street_ua} ${department.building_no}`;
            },
            applyFilters() {
                let data = {};
                // если смотрим Входящие, то подменяем поля поиска на данные отправителя
                if( this.isIncomming ){
                    for(const k in this.filters){
                        const key = k.replace('receiver_', 'sender_');
                        data[key] = this.filters[k];
                    }
                }
                else {
                    data = this.filters;
                }
                this.$emit('filter', data);
            },
            resetFilters() {
                const filterKeys = Object.keys(this.filters);
                filterKeys.forEach(v => {
                    this.filters[v] = '';
                    if( this.filledInputs[v] ){
                        this.filledInputs[v] = false;
                    }
                });
                this.resetPlaceholders();
                // возвращаем все департаменты
                this.availableDepartments = this.departments;
                this.applyFilters();
            },
            resetPlaceholders(){
                this.placeholders.receiver_city = '';
                this.placeholders.receiver_department = '';
            }
        },
        watch: {
            departments: function(newDepartments){
                this.availableDepartments = newDepartments;
            }
        },
        created() {
            Settings.defaultLocale = 'uk'
        }
    }
</script>
